"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.register = void 0;
const rename_1 = require("./rename");
function register({ sourceFiles, getTsLs }) {
    return async (codeAction) => {
        const data = codeAction.data;
        const tsCodeAction = {
            ...codeAction,
            data: data.tsData,
        };
        codeAction = await getTsLs(data.lsType).doCodeActionResolve(tsCodeAction);
        if (codeAction.edit) {
            codeAction.edit = rename_1.tsEditToVueEdit(data.lsType, codeAction.edit, sourceFiles, () => true);
        }
        return codeAction;
    };
}
exports.register = register;
//# sourceMappingURL=codeActionResolve.js.map